ACT_LOCATE_OBJECT
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg3(a2),(a3)+
		move.l	dp_Arg2(a2),a0
		bsr	copybstr
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

ACT_COPY_DIR
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		clr.l	dp_Arg2(a2)
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

ACT_PARENT
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		move.l	#slashname,d0
		lsr.l	#2,d0
		move.l	d0,dp_Arg2(a2)
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

ACT_CREATE_DIR
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg2(a2),a0
		bsr	copybstr
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

createlock_ret
		movem.l	(a3)+,d0/d1
		move.l	d0,d2
		beq	.return

		** Find volume node
		move.l	(a3)+,d1
		bsr	FindCorrVolume
		move.l	d0,d3
		move.l	a1,a4

		** Create FileLock
		move.l	#phl_SIZEOF,d0
		bsr	AllocVec
		tst.l	d0
		beq	.error
		move.l	d0,a0

		move.l	phvn_locklist(a4),(a0)
		move.l	a0,phvn_locklist(a4)

		move.l	(a3),fl_Access(a0)
		move.l	ourport(pc),fl_Task(a0)
		move.l	d3,fl_Volume(a0)
		lea	phl_ext(a0),a1
		move.l	a1,fl_Key(a0)
		move.l	d2,pho_serverobject(a1)

		** Create name string
		move.l	a0,a4
		lea	phl_ext(a4),a0
		move.l	dp_Arg1(a2),d0
		move.l	dp_Arg2(a2),d1
		bsr	GeneratePath

		IFNE	DEBUG
		lea	dlockt(pc),a0
		bsr	dtype
		lea	phl_ext+pho_path(a4),a0
		bsr	dtype
		ENDC

		move.l	a4,d0
		lsr.l	#2,d0

.return		bra	ReturnPacket

.error		lea	sendbuf,a3
		move.l	#ACTION_FREE_LOCK,(a3)+
		move.l	d2,(a3)+
		bsr	sendpnpacket
		move.l	#DOSFALSE,d0
		move.l	#ERROR_NO_FREE_STORE,d1
		bra	ReturnPacket

ACT_FREE_LOCK
		GETBPTR	dp_Arg1(a2),d0
		beq.s	.return

		move.l	d0,a4
		bsr	ForgetLock

		move.l	fl_Key(a4),a0
		move.l	pho_serverobject(a0),(a3)+
		beq.s	.0
		bsr	sendpnpacket
.0		clr.l	fl_Task(a4)
		move.l	a4,a1
		LIBCALL	FreeVec

.return		moveq	#DOSTRUE,d0
		bra	ReturnPacket
		rts

ACT_DELETE_OBJECT
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg2(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket



ACT_RENAME_OBJECT
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		GETsFL	dp_Arg3(a2)
		move.l	a0,(a3)+
		lea	256(a3),a5
		move.l	dp_Arg2(a2),a0
		bsr	copybstr
		move.l	a5,a3
		move.l	dp_Arg4(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket

ACT_SET_PROTECT
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg4(a2),(a3)+
		move.l	dp_Arg3(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket


ACT_EXAMINE_OBJECT
		GETsFL	dp_Arg1(a2)
act_ex_entry	move.l	a0,(a3)+
		GETBPTR	dp_Arg2(a2),a0
		** fib_DiskKey
		move.l	(a0)+,(a3)+
		addq.l	#4,a0
		move.w	#32/4-1,d0
		** fib_FileName
.copyname	move.l	(a0)+,(a3)+
		dbra	d0,.copyname
		lea	act_ex_ret(pc),a0
		bra	sendpnpacket

act_ex_ret	movem.l	(a3)+,d0/d1
		GETBPTR	dp_Arg2(a2),a0
		move.w	#fib_SIZEOF/4-1,d2
.copyfib	move.l	(a3)+,(a0)+
		dbra	d2,.copyfib
		bra	ReturnPacket


ACT_SET_COMMENT
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg4(a2),a0
		add.l	a0,a0
		add.l	a0,a0
		moveq	#80/4-1,d2
.1		move.l	(a0)+,(a3)+
		dbra	d2,.1
		move.l	dp_Arg3(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket


ACT_SET_DATE
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg4(a2),a0
		move.l	(a0)+,(a3)+
		move.l	(a0)+,(a3)+
		move.l	(a0)+,(a3)+
		move.l	dp_Arg3(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket

ACT_SAME_LOCK
		GETBPTR	dp_Arg1(a2),a0
		GETBPTR	dp_Arg2(a2),a1
		cmp.l	a0,a1
		beq.s	.equal

		move.l	fl_Volume(a0),d0
		cmp.l	fl_Volume(a1),d0
		bne.s	.not_equal

		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		lea	stdreturn(pc),a0
		bra	sendpnpacket

.not_equal	moveq	#DOSFALSE,d0
		moveq	#0,d1
.return		bra	ReturnPacket

.equal		moveq	#DOSTRUE,d0
		bra	ReturnPacket


ACT_MAKE_LINK
		move.l	dp_Arg4(a2),d2
		move.l	d2,(a3)+
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		cmp.l	#LINK_HARD,d2
		beq.s	.hardlink
.softlink	lea	256(a3),a5
		move.l	dp_Arg3(a2),a0
.0		move.b	(a0)+,(a3)+
		bne.s	.0
		move.l	a5,a3
		bra.s	.doit
.hardlink	GETsFL	dp_Arg3(a2)
		move.l	a0,(a3)+
.doit		move.l	dp_Arg2(a2),a0
		bsr	copybstr
		lea	stdreturn(pc),a0
		bra	sendpnpacket



ACT_READ_LINK
		GETsFL	dp_Arg1(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg4(a2),(a3)+
		move.l	dp_Arg2(a2),a0
.0		move.b	(a0)+,(a3)+
		bne.s	.0
		lea	.ret(pc),a0
		bra	sendpnpacket
.ret
		movem.l	(a3)+,d0/d1
		move.l	dp_Arg4(a2),d2
		subq.w	#1,d2
		move.l	dp_Arg3(a2),a1
.copy		move.b	(a3)+,(a1)+
		dbra	d2,.copy
		bra	ReturnPacket

; -- Remove a lock from a volume's lock list. All volume nodes are searched.
; -- If the volume is unmounted and no locks are open, remove it completely.
ForgetLock	; a4 *Lock
		movem.l	d2/a2/a3,-(sp)

		lea	PHVNList+LH_HEAD(pc),a3
.nextphvn	move.l	(a3),a3
		tst.l	(a3)
		beq.s	.ende

		lea	phvn_locklist(a3),a0
.searchlock	move.l	a0,a1
		move.l	(a0),a0
		move.l	a0,d0
		beq.s	.nextphvn
		cmp.l	a4,d0
		bne.s	.searchlock

		move.l	(a4),(a1)

		tst.l	phvn_locklist(a3)
		bne.s	.ende
		move.l	phvn_volnode(a3),a0
		tst.l	dol_Task(a0)
		bne.s	.ende
		move.l	a3,a2
		bsr	RemoveVolNode

		pea	0.w
		jsr	_SendInputEvent
		addq.l	#4,sp

.ende		movem.l	(sp)+,d2/a2/a3
		rts
