ACT_FINDxxx
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		move.l	dp_Arg3(a2),a0
		bsr	copybstr
		lea	.ret(pc),a0
		bra	sendpnpacket
.ret
		movem.l	(a3)+,d0/d1
		tst.w	d0
		beq.s	.return
		GETBPTR	dp_Arg1(a2),a0
		move.l	(a3)+,fh_Arg1(a0)
		move.l	(a3),fh_Interactive(a0)
.return		bra	ReturnPacket

ACT_FH_FROM_LOCK
		GETsFL	dp_Arg2(a2)
		move.l	a0,(a3)+
		lea	.ret(pc),a0
		bra	sendpnpacket
.ret
		movem.l	(a3),d0/d1
		tst.w	d0
		beq.s	.return
		GETBPTR	dp_Arg1(a2),a0
		move.l	8(a3),fh_Arg1(a0)
		move.l	12(a3),fh_Interactive(a0)
		GETBPTR	dp_Arg2(a2),a4
		clr.l	fl_Task(a4)
		bsr	ForgetLock
		move.l	a4,a1
		LIBCALL	FreeVec
		movem.l	(a3),d0/d1
.return		bra	ReturnPacket

ACT_EXAMINE_FH
		move.l	dp_Arg1(a2),a0
		bra	act_ex_entry

ACT_READ	** new routine 17-04-95
		move.l	dp_Arg1(a2),(a3)+
		move.l	dp_Arg3(a2),(a3)+
		lea	.ret(pc),a0
		bra	sendpnpacket
.ret
		move.l	dp_Arg2(a2),a4	* Destination Buffer
		move.l	dp_Arg3(a2),d7	* Bytes to be read
		moveq	#0,d6		* Bytes already read

		move.l	curpronetmsg(pc),d5 *current pronetmsg
		bra.s	.jump_in

.loop		move.l	pronetport(pc),a0	*Get the Message
		LIBCALL	WaitPort
		move.l	pronetport(pc),a0
		LIBCALL	GetMsg
		move.l	d0,d5
.jump_in	move.l	d5,a3
		lea	MN_SIZE+4(a3),a3
		move.l	(a3),d4
		cmp.l	#-1,d4
		beq.s	.ERROR

		lea	8(a3),a0		*Copy
		move.l	a4,a1
		move.l	d4,d0
		LIBCALL	CopyMem

		move.l	d5,a1
		LIBCALL	ReplyMsg
		clr.l	curpronetmsg

		tst.l	d4
		beq.s	.EOF

		add.l	d4,d6
		add.l	d4,a4
		sub.l	d4,d7
		bgt.s	.loop

.EOF		move.l	d6,d0
		moveq	#0,d1
		bra	ReturnPacket

.ERROR		movem.l	(a3),d2/d3
		move.l	d5,a1
		LIBCALL	ReplyMsg
		clr.l	curpronetmsg
		move.l	d2,d0
		move.l	d3,d1
		bra	ReturnPacket


ACT_WRITE
		move.l	dp_Arg1(a2),(a3)+
		move.l	dp_Arg3(a2),(a3)+
		lea	.ret(pc),a0
		bra	sendpnpacket
.ret
		movem.l	(a3)+,d0/d1
		cmp.l	#-1,d0
		beq.s	.return

		move.l	dp_Arg3(a2),d4	;Number of Bytes to be transferred
		move.l	4.w,a6
		move.l	pronetio(pc),a3
		move.l	dp_Arg2(a2),a4

.sendloop	move.l	a4,pnr_Data(a3)	;Split chunk in parts
		move.l	#MAXPACKETSIZE,d0	;and send them..
		cmp.l	d0,d4
		bcc.s	.0
		move.l	d4,d0
.0		move.l	d0,pnr_Length(a3)
		add.l	d0,a4
		sub.l	d0,d4
		move.l	a3,a1
		LIBCALL	DoIO
		tst.l	d4
		bgt.s	.sendloop

		move.l	pronetport(pc),a0
		LIBCALL	WaitPort
		move.l	pronetport(pc),a0
		LIBCALL	GetMsg
		move.l	d0,d6
		move.l	d0,a0
		move.l	MN_SIZE+4(a0),d2
		move.l	MN_SIZE+8(a0),d3
		move.l	d6,a1
		LIBCALL	ReplyMsg
		move.l	d2,d0
		move.l	d3,d1

.return		bra	ReturnPacket


ACT_END
		move.l	dp_Arg1(a2),(a3)+
		lea	stdreturn(pc),a0
		bra	sendpnpacket

ACT_SEEK
		move.l	dp_Arg1(a2),(a3)+
		move.l	dp_Arg2(a2),(a3)+
		move.l	dp_Arg3(a2),(a3)+
		lea	stdreturn(pc),a0
		bra	sendpnpacket


ACT_COPY_DIR_FH
		move.l	dp_Arg1(a2),(a3)+
		clr.l	dp_Arg2(a2)
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

ACT_PARENT_FH
		move.l	dp_Arg1(a2),(a3)+
		move.l	#slashname,d0
		lsr.l	#2,d0
		move.l	d0,dp_Arg2(a2)
		lea	createlock_ret(pc),a0
		bra	sendpnpacket

ACT_LOCK_RECORD
		move.l	dp_Arg1(a2),(a3)+
		move.l	dp_Arg2(a2),(a3)+
		move.l	dp_Arg3(a2),(a3)+
		move.l	dp_Arg4(a2),(a3)+
		move.l	dp_Arg5(a2),(a3)+
		lea	stdreturn(pc),a0
		bra	sendpnpacket
