/*
	packets.c

*/

#include <dos/dosextens.h>
#include <dos/filehandler.h>

#include <proto/exec.h>

#include "packets.h"

void ReturnPacket(struct DosPacket *packet, LONG res1, LONG res2)
{
	struct MsgPort *mp = packet->dp_Port;

	packet->dp_Port = ourport;
	packet->dp_Res1 = res1;
	packet->dp_Res2 = res2;

	PutMsg(mp, packet->dp_Link);
}

struct DosPacket *GetPacket(struct MsgPort *port)
{
	struct Message *msg;

	if((msg = GetMsg(port)))
		return((struct DosPacket *)msg->mn_Node.ln_Name);
	else
		return(NULL);
}
